
module temp;


template Foo(Type)
{
  bit isSorted(Type[] array, int delegate(Type a,Type b) cmp)
  {
    for(int i = 1; i < array.length; ++i)
    {
      if(cmp(array[i-1],array[i]) > 0)
        return false;
    }
        
    return true;
  }


  void insertionSort(Type array[], int delegate(Type a,Type b) cmp)
  in
  {
    assert(cmp);
  }
  out
  {
    assert(isSorted(array,cmp));
  }
  body
  {
    for (int i=1; i < array.length; i++)
    {
      Type index = array[i];
      int j = i;
      while ((j > 0) && cmp(index,array[j-1]) == -1)
      {
        array[j] = array[j-1];
        j = j - 1;
      }
      array[j] = index;
    }
  }
}

